'
' Copyright (c) 2015, MindFusion LLC - Bulgaria.
'

Public Class MainForm

	Public Sub New()

		' This call is required by the designer.
		InitializeComponent()

		' Add any initialization after the InitializeComponent() call.
		UpdateTime()

	End Sub

    Private Sub clock_PrepaintBackground(ByVal sender As Object, ByVal e As PrepaintEventArgs) Handles clock.PrepaintBackground
        e.CancelDefaultPainting = True

        Dim bounds As RectangleF = New RectangleF(0, 0, e.Element.RenderSize.Width, e.Element.RenderSize.Height)

        ' ---------------------- Ellipse #1 ----------------------
        Dim stroke1 As Pen = New Pen(Color.FromArgb(122, 123, 124), 0.01F)
        Dim fill1 As Brush = New Drawing2D.LinearGradientBrush( _
            New PointF(0, 0.5F), New PointF(1, 0.5F), _
            Color.FromArgb(245, 245, 245), _
            Color.FromArgb(151, 156, 160))

        ' Inflate with half the stroke thickness
        bounds.Inflate(-stroke1.Width / 2, -stroke1.Width / 2)

        e.Graphics.FillEllipse(fill1, bounds)
        e.Graphics.DrawEllipse(stroke1, bounds)

        fill1.Dispose()
        stroke1.Dispose()

        ' Apply margin of 0.025
        bounds.Inflate(-0.025F * bounds.Width, -0.025F * bounds.Height)

        ' ---------------------- Ellipse #2 ----------------------
        Dim fill2Path As Drawing2D.GraphicsPath = New Drawing2D.GraphicsPath()
        fill2Path.AddEllipse(bounds)

        Dim fill2 As Drawing2D.PathGradientBrush = _
            New Drawing2D.PathGradientBrush(fill2Path)
        fill2.CenterPoint = New PointF(1, 1)

        Dim fill2Blend As Drawing2D.ColorBlend = New Drawing2D.ColorBlend()
        fill2Blend.Positions = New Single() {0, 0.3F, 0.7F, 1}
        fill2Blend.Colors = New Color() {Color.FromArgb(225, 236, 238), _
            Color.FromArgb(225, 236, 235), Color.White, Color.White}
        fill2.InterpolationColors = fill2Blend

        e.Graphics.FillEllipse(fill2, bounds)

        fill2.Dispose()
        fill2Path.Dispose()

        ' ---------------------- Ellipse #3 ----------------------
        Dim fill3Path As Drawing2D.GraphicsPath = New Drawing2D.GraphicsPath()
        fill3Path.AddEllipse(bounds)

        Dim fill3 As Drawing2D.PathGradientBrush = _
            New Drawing2D.PathGradientBrush(fill3Path)

        Dim fill3Blend As Drawing2D.ColorBlend = New Drawing2D.ColorBlend()
        fill3Blend.Positions = New Single() {0, 0.03F, 0.09F, 0.13F, 1}
        fill3Blend.Colors = New Color() {Color.FromArgb(0, Color.Black), _
           Color.FromArgb(0, Color.Black), Color.FromArgb(32, Color.Black), _
           Color.FromArgb(0, Color.Black), Color.FromArgb(0, Color.Black)}
        fill3.InterpolationColors = fill3Blend

        e.Graphics.FillEllipse(fill3, bounds)

        fill3.Dispose()
        fill3Path.Dispose()

        ' ---------------------- Ellipse #4 ----------------------
        Dim stroke4 As Pen = New Pen(Color.FromArgb(124, 137, 154), 0.01F)

        ' Inflate with half the stroke thickness
        bounds.Inflate(-stroke4.Width / 2, -stroke4.Width / 2)

        e.Graphics.DrawEllipse(stroke4, bounds)

        stroke4.Dispose()
    End Sub

    Private Sub clock_PrepaintForeground(ByVal sender As Object, ByVal e As PrepaintEventArgs) Handles clock.PrepaintForeground
        e.CancelDefaultPainting = True

        Dim bounds As RectangleF = New RectangleF(0, 0, e.Element.RenderSize.Width, e.Element.RenderSize.Height)

        Dim areaPath As Drawing2D.GraphicsPath = New Drawing2D.GraphicsPath()
        areaPath.AddEllipse(bounds)

        Dim area1Fill As MindFusion.Drawing.PathGradientBrush = _
            New MindFusion.Drawing.PathGradientBrush( _
                Color.FromArgb(153, Color.White), Color.Transparent)
        area1Fill.Path = areaPath

        Dim area2Fill As MindFusion.Drawing.PathGradientBrush = _
            New MindFusion.Drawing.PathGradientBrush( _
            Color.FromArgb(32, Color.White), Color.Transparent)
        area2Fill.Path = areaPath

        Dim area1 As ArcArea = New ArcArea()
        area1.RelativeCoordinates = False
        area1.StartAngle = 160
        area1.EndAngle = -20
        area1.Margin = New Thickness(0.03F)
        area1.Fill = area1Fill

        Dim area2 As ArcArea = New ArcArea()
        area2.RelativeCoordinates = False
        area2.StartAngle = 140
        area2.EndAngle = -40
        area2.Margin = New Thickness(0.03F)
        area2.Fill = area2Fill

        e.PaintVisualElement(area1, e.Element.RenderSize)
        e.PaintVisualElement(area2, e.Element.RenderSize)

        areaPath.Dispose()
    End Sub

    Private Sub clock_PrepaintPointer(ByVal sender As Object, ByVal e As PrepaintEventArgs) Handles clock.PrepaintPointer
        e.CancelDefaultPainting = True

        Dim state As Drawing2D.GraphicsState = e.Graphics.Save()
        e.Graphics.ScaleTransform(e.Element.RenderSize.Width, e.Element.RenderSize.Height)

        Dim fill As Brush = New SolidBrush(Color.FromArgb(94, 98, 99))

        If e.Element.Name = "HourHand" Then
            e.Graphics.FillRectangle(fill, 0, 0.3F, 1.0F, 0.4F)
            e.Graphics.FillEllipse(fill, 0, 0, 0.08F, 1.0F)
        ElseIf e.Element.Name = "MinuteHand" Then
            e.Graphics.FillRectangle(fill, 0, 0.3F, 1.0F, 0.4F)
            e.Graphics.FillEllipse(fill, 0, 0, 0.05F, 1.0F)
        ElseIf e.Element.Name = "SecondHand" Then
            e.Graphics.FillRectangle(fill, 0, 0.4F, 1.0F, 0.2F)
            e.Graphics.FillEllipse(fill, 0, 0, 0.04F, 1.0F)
        End If
        e.Graphics.Restore(state)
        fill.Dispose()
    End Sub

	Private Sub timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles timer.Tick

		UpdateTime()

	End Sub

	Private Sub UpdateTime()

		Dim hourHand As Pointer = clock.GetElementByName("HourHand")
		Dim minuteHand As Pointer = clock.GetElementByName("MinuteHand")
		Dim secondHand As Pointer = clock.GetElementByName("SecondHand")

		Dim now As TimeSpan = DateTime.Now.TimeOfDay
		hourHand.Value = CType(((now.TotalHours * 5) Mod 60), Single)
		minuteHand.Value = CType((now.TotalMinutes Mod 60), Single)
		secondHand.Value = now.Seconds

	End Sub

End Class
